import pluginVue from 'eslint-plugin-vue';
import vueTsEslintConfig from '@vue/eslint-config-typescript';
import pluginVitest from '@vitest/eslint-plugin';
import pluginCypress from 'eslint-plugin-cypress/flat';
import skipFormatting from '@vue/eslint-config-prettier/skip-formatting';

export default [
  {
    name: 'app/files-to-lint',
    files: ['**/*.{ts,mts,tsx,vue}'],
  },

  {
    name: 'app/files-to-ignore',
    ignores: ['**/dist/**', '**/dist-ssr/**', '**/coverage/**'],
  },

  ...pluginVue.configs['flat/essential'],
  ...vueTsEslintConfig(),

  {
    ...pluginVitest.configs.recommended,
    files: ['src/**/__tests__/*'],
  },

  {
    ...pluginCypress.configs.recommended,
    files: ['cypress/e2e/**/*.{cy,spec}.{js,ts,jsx,tsx}', 'cypress/support/**/*.{js,ts,jsx,tsx}'],
  },
  {
    plugins: {
      tailwindcss: pluginTailwindCSS,
    },
    rules: {
      'tailwindcss/no-custom-classname': 'off', // 允许自定义类名
    },
  },
  {
    files: ['**/*.{ts,mts,tsx,vue}'], // 针对 TypeScript 文件
    rules: {
      '@typescript-eslint/no-explicit-any': 'off', // 关闭禁止使用 any 类型的规则
    },
  },
  skipFormatting,
];
